//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "IPMaskEdit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck ͍쐬ꂽR|[lgz֐ȂƂ
// ۏ؂邽߂Ɏgp܂B
//

static inline void ValidCtrCheck(TAddressMaskEdit *)
{
	new TAddressMaskEdit(NULL);
}
//---------------------------------------------------------------------------
__fastcall TAddressMaskEdit::TAddressMaskEdit(TComponent* Owner)
	: TMaskEdit(Owner)
{
}
//---------------------------------------------------------------------------
namespace Addressmaskedit
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TAddressMaskEdit)};
		RegisterComponents("Samples", classes, 0);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAddressMaskEdit::CheckAddress()
{
	ValidateEdit();
	if (IPType)
	{
		int n[4];
		int i(0);
		n[0] = 0;
		n[1] = n[2] = n[3] = -1;
		int ix;
		for (ix = 1; ix <= Text.Length(); ix++)
		{
			if (isdigit(Text[ix])) break;
		}
		if (ix >= Text.Length())
			ValidateError();
		for (ix = 1; ix <= Text.Length(); ix++)
		{
			if (isdigit(Text[ix]))
			{
				n[i] *= 10;
				n[i] += Text[ix] - '0';
			}
			else
			{
				if (i == 3) break;
				if (n[i + 1] < 0)
				{
					i++;
					n[i] = 0;
				}
			}
		}
		if (i < 3 || n[0] >= 256 || n[1] >= 256 || n[2] >= 256 || n[3] >= 256)
		{
			ValidateError();
		}
	}
	else
	{
		for (int i = 1; i <= Text.Length(); i++)
		{
			if (Text[i] != '-' && !isxdigit(Text[i]))
			{
				ValidateError();
				break;
			}
		}
	}
}

void __fastcall TAddressMaskEdit::SetAddressType(bool IP)
{
	IPType = IP;
	if (IP)
	{
		EditMask = "999.999.999.999;1;_";
	}
	else
	{
		EditMask = ">AA-AA-AA-AA-AA-AA;1;_";
	}
}

AnsiString& __fastcall TAddressMaskEdit::GetResultString()
{
	ResultString = "";
	if (IPType)
	{
		for (int i = 1; i <= Text.Length(); i++)
		{
			if (isdigit(Text[i]) || Text[i] == '.')
				ResultString += Text[i];
		}
	}
	else
		ResultString = Text;
	return ResultString;
}

