//---------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop

#include "ProtocolSelect.h"
#include "MACCAPLib_TLB.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TProtocolSelectDlg *ProtocolSelectDlg;
//---------------------------------------------------------------------
__fastcall TProtocolSelectDlg::TProtocolSelectDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TProtocolSelectDlg::FormCreate(TObject *Sender)
{
	int defIndex(0);
	IProtocolNameCollection* pProtoColl;
	HRESULT hr = CoCreateInstance(CLSID_ProtocolNameCollection, NULL, CLSCTX_INPROC_SERVER,
		IID_IProtocolNameCollection, (void**)&pProtoColl);
	if (hr == S_OK)
	{
		IUnknown* pUnk;
		if (pProtoColl->get__NewEnum(&pUnk) == S_OK)
		{
			IEnumVARIANT* pEnum;
			if (pUnk->QueryInterface(IID_IEnumVARIANT, (void**)&pEnum) == S_OK)
			{
				ULONG ul;
				VARIANT v;
				VariantInit(&v);
				while (pEnum->Next(1, &v, &ul) == S_OK)
				{
					if (v.vt == VT_DISPATCH)
					{
						INameValuePair* pNV;
						if (v.pdispVal->QueryInterface(IID_INameValuePair, (void**)&pNV) == S_OK)
						{
							BSTR bstr;
							VARIANT vVal;
							VariantInit(&vVal);
							pNV->get_Value(&vVal);
							pNV->get_Name(&bstr);
							int idx = ProtList->Items->Add(OleStrToString(bstr));
							ProtList->Items->Objects[idx] = (TObject*)vVal.iVal;
							if (vVal.iVal == TCP)
								defIndex = idx;
							VariantClear(&vVal);
							SysFreeString(bstr);
							pNV->Release();
						}
    				}
					VariantClear(&v);
				}
				pEnum->Release();
			}
			pUnk->Release();
		}
		pProtoColl->Release();
	}
	ProtList->ItemIndex = defIndex;
}
//---------------------------------------------------------------------------

void __fastcall TProtocolSelectDlg::OKBtnClick(TObject *Sender)
{
	int idx = ProtList->ItemIndex;
	if (idx >= 0)
	{
		ProtocolName = ProtList->Items->Strings[idx];
		Protocol = (short)ProtList->Items->Objects[idx];
	}
}
//---------------------------------------------------------------------------

