//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef ADDRESSETH
#define ADDRESSETH
//----------------------------------------------------------------------------
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <Mask.hpp>
#include "IPMaskEdit.h"
//----------------------------------------------------------------------------
class TAddressInputDlg : public TForm
{
__published:
	TButton *OKBtn;
	TButton *CancelBtn;
	TLabel *Label;
	TAddressMaskEdit *MaskEdit;
	TRadioGroup *RadioGroup1;

	TRadioButton *RadioBtnSrc;
	TRadioButton *RadioBtnDst;
	TRadioButton *RadioBtnBi;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);

private:
	bool IPMode;
	AnsiString ResultString;
public:
	enum DirectionType {
		DT_BI = 2,
		DT_DST = 1,
		DT_SRC = 0,
	};
	virtual __fastcall TAddressInputDlg(TComponent* AOwner);
	void InitDlg(bool IP);
	void SetDefault(DirectionType, AnsiString& as);
	inline AnsiString& GetResult() { return ResultString; }
	int GetDirection();
};
//----------------------------------------------------------------------------
extern PACKAGE TAddressInputDlg *AddressInputDlg;
//----------------------------------------------------------------------------
#endif
