//  Copyright(c) 1999 arton
#ifndef __ASSIGNED_NUMBER_HEADER
#define __ASSIGNED_NUMBER_HEADER

// EtherType.cpp
struct SEtherType {
  WORD wLow;
  WORD wHigh;
  LPCOLESTR pDesc;
};
LPCOLESTR GetEtherTypeString(LPBYTE pb);
int GetEtherTypeTableSize();
const SEtherType& SearchEtherType(WORD w);
const SEtherType* GetEtherType(int i);

// IPName.cpp
#define MAX_PROTO 255
LPCOLESTR GetProtoName(BYTE b);
bool IsAssigned(BYTE b);
int GetIPNameTableSize();

// Vendor.cpp
struct SVendor {
	DWORD dwCode;
	LPCOLESTR pVendor;
};

LPCOLESTR GetVendorString(LPBYTE);
int GetVendorTableSize();
const SVendor& SearchVendor(LPBYTE pb);
const SVendor* GetVendor(int);

// MultiCast.cpp
struct SMultiCast {
  BYTE mcastLow[6];
  BYTE mcastHigh[6];
  WORD etype;
  int size;
  LPCOLESTR pDescription;
};
bool IsMulticast(LPBYTE);
bool IsBroadcast(LPBYTE);
LPCOLESTR GetMulticastDescription(LPBYTE, WORD);

#endif
