// Copyright(c) 1999 arton
#include "stdafx.h"
#include "AssNum.h"

const static SVendor vendors[] = {
// Copyright notice.
// This table was configured upon the information by Michael A. Patton.
// http://www.cavebear.com/CaveBear/Ethernet/vendor.html
// $Revision: 2.194 $
// $Date: 1999/03/09 10:30:19 $
// $Author: map $
// $Id: vendor.html,v 2.194 1999/03/09 10:30:19 map Exp $
// 
// Many thanks to Michael.
// 
  { 0x000001, L"SuperLAN-2U", },
  { 0x000002, L"BBN (was internal usage only, no longer used)", },
  { 0x000009, L"powerpipes\?", },
  { 0x00000C, L"Cisco", },
  { 0x00000E, L"Fujitsu", },
  { 0x00000F, L"NeXT", },
  { 0x000010, L"Hughes LAN Systems (formerly Sytek)", },
  { 0x000011, L"Tektronix", },
  { 0x000015, L"Datapoint Corporation", },
  { 0x000018, L"Webster Computer Corporation Appletalk/Ethernet Gateway", },
  { 0x00001A, L"AMD (\?)", },
  { 0x00001B, L"Novell (now Eagle Technology)", },
  { 0x00001C, L"JDR Microdevices generic, NE2000 drivers", },
  { 0x00001D, L"Cabletron", },
  { 0x00001F, L"Cryptall Communications Corp.", },
  { 0x000020, L"DIAB (Data Intdustrier AB)", },
  { 0x000021, L"SC&C (PAM Soft&Hardware also reported)", },
  { 0x000022, L"Visual Technology", },
  { 0x000023, L"ABB Automation AB, Dept. Q", },
  { 0x000024, L"Olicom", },
  { 0x000029, L"IMC", },
  { 0x00002A, L"TRW", },
  { 0x00002C, L"NRC - Network Resources Corporation - MultiGate Hub1+, Hub2, etc", },
  { 0x000032, L"GPT Limited (reassigned from GEC Computers Ltd)", },
  { 0x000037, L"Oxford Metrics Ltd", },
  { 0x00003B, L"Hyundai/Axil Sun clones", },
  { 0x00003C, L"Auspex", },
  { 0x00003D, L"AT&T", },
  { 0x00003F, L"Syntrex Inc", },
  { 0x000044, L"Castelle", },
  { 0x000046, L"ISC-Bunker Ramo, An Olivetti Company", },
  { 0x000048, L"Epson", },
  { 0x000049, L"Apricot Ltd.", },
  { 0x00004B, L"APT -ICL also reported", },
  { 0x00004C, L"NEC Corporation", },
  { 0x00004F, L"Logicraft 386-Ware P.C. Emulator", },
  { 0x000051, L"Hob Electronic Gmbh & Co. KG", },
  { 0x000052, L"Optical Data Systems", },
  { 0x000055, L"AT&T", },
  { 0x000058, L"Racore Computer Products Inc", },
  { 0x00005A, L"SK (Schneider & Koch in Europe and Syskonnect outside of Europe)", },
  { 0x00005A, L"Xerox 806 (unregistered)", },
  { 0x00005B, L"Eltec", },
  { 0x00005D, L"RCE", },
  { 0x00005E, L"U.S. Department of Defense (IANA)", },
  { 0x00005F, L"Sumitomo", },
  { 0x000061, L"Gateway Communications", },
  { 0x000062, L"Honeywell", },
  { 0x000063, L"Hewlett-Packard LanProbe", },
  { 0x000064, L"Yokogawa Digital Computer Corp", },
  { 0x000065, L"Network General", },
  { 0x000066, L"Talaris", },
  { 0x000068, L"Rosemount Controls", },
  { 0x000069, L"Concord Communications, Inc (although someone said Silicon Graphics)", },
  { 0x00006B, L"MIPS", },
  { 0x00006D, L"Case", },
  { 0x00006E, L"Artisoft, Inc.", },
  { 0x00006F, L"Madge Networks Ltd. Token-ring adapters", },
  { 0x000073, L"DuPont", },
  { 0x000075, L"Bell Northern Research (BNR)", },
  { 0x000077, L"Interphase [Used in other systems, e.g. MIPS, Motorola]", },
  { 0x000078, L"Labtam Australia", },
  { 0x000079, L"Networth Incorporated [bought by Compaq, used in Netelligent series]", },
  { 0x00007A, L"Ardent", },
  { 0x00007B, L"Research Machines", },
  { 0x00007D, L"Cray Research Superservers,Inc [Also Harris (3M) (old)]", },
  { 0x00007E, L"NetFRAME multiprocessor network servers", },
  { 0x00007F, L"Linotype-Hell AG Linotronic typesetters", },
  { 0x000080, L"Cray Communications (formerly Dowty Network Services) [Also shows as \"Harris (3M) (new)\" and/or \"Imagen(\?)\" elsewhere]", },
  { 0x000081, L"Synoptics", },
  { 0x000083, L"Tadpole Technology [had Optical Data Systems which is wrong according to both]", },
  { 0x000084, L"Aquila (\?), ADI Systems Inc.(\?)", },
  { 0x000086, L"Gateway Communications Inc. (then Megahertz & now 3com)", },
  { 0x000087, L"Hitachi", },
  { 0x000089, L"Cayman Systems Gatorbox", },
  { 0x00008A, L"Datahouse Information Systems", },
  { 0x00008E, L"Solbourne(\?), Jupiter(\?) (I\'ve had confirming mail on Solbourne)", },
  { 0x000092, L"Unisys, Cogent (both reported)", },
  { 0x000093, L"Proteon", },
  { 0x000094, L"Asante MAC", },
  { 0x000095, L"Sony/Tektronix", },
  { 0x000097, L"Epoch", },
  { 0x000098, L"Cross Com", },
  { 0x000099, L"Memorex Telex Corporations", },
  { 0x00009F, L"Ameristar Technology", },
  { 0x0000A0, L"Sanyo Electronics", },
  { 0x0000A2, L"Wellfleet", },
  { 0x0000A3, L"Network Application Technology (NAT)", },
  { 0x0000A4, L"Acorn", },
  { 0x0000A5, L"Compatible Systems Corporation", },
  { 0x0000A6, L"Network General (internal assignment, not for products)", },
  { 0x0000A7, L"Network Computing Devices (NCD) X-terminals", },
  { 0x0000A8, L"Stratus Computer, Inc.", },
  { 0x0000A9, L"Network Systems", },
  { 0x0000AA, L"Xerox Xerox machines", },
  { 0x0000AC, L"Conware Netzpartner [had Apollo, claimed incorrect]", },
  { 0x0000AE, L"Dassault Automatismes et Telecommunications", },
  { 0x0000AF, L"Nuclear Data Acquisition Interface Modules (AIM)", },
  { 0x0000B0, L"RND (RAD Network Devices)", },
  { 0x0000B1, L"Alpha Microsystems Inc.", },
  { 0x0000B3, L"CIMLinc", },
  { 0x0000B4, L"Edimax", },
  { 0x0000B5, L"Datability Terminal Servers", },
  { 0x0000B6, L"Micro-matic Research", },
  { 0x0000B7, L"Dove Fastnet", },
  { 0x0000BB, L"TRI-DATA Systems Inc. Netway products, 3274 emulators", },
  { 0x0000BC, L"Allen-Bradley", },
  { 0x0000C0, L"Western Digital now SMC (Std. Microsystems Corp.)", },
  { 0x0000C1, L"Olicom A/S", },
  { 0x0000C5, L"Farallon Computing Inc", },
  { 0x0000C6, L"HP Intelligent Networks Operation (formerly Eon Systems)", },
  { 0x0000C8, L"Altos", },
  { 0x0000C9, L"Emulex Terminal Servers, Print Servers", },
  { 0x0000CA, L"LANcity Cable Modems (now owned by BayNetworks)", },
  { 0x0000CC, L"Densan Co., Ltd.", },
  { 0x0000CD, L"Industrial Research Limited", },
  { 0x0000D0, L"Develcon Electronics, Ltd.", },
  { 0x0000D1, L"Adaptec, Inc. \"Nodem\" product", },
  { 0x0000D2, L"SBE Inc", },
  { 0x0000D3, L"Wang Labs", },
  { 0x0000D4, L"PureData", },
  { 0x0000D7, L"Dartmouth College (NED Router)", },
  { 0x0000D8, L"old Novell NE1000\'s (before about 1987\?) (also 3Com)", },
  { 0x0000DD, L"Gould", },
  { 0x0000DE, L"Unigraph", },
  { 0x0000E1, L"Hitachi (laptop built-in)", },
  { 0x0000E2, L"Acer Counterpoint", },
  { 0x0000E3, L"Integrated Micro Products Ltd", },
  { 0x0000E4, L"mips\?", },
  { 0x0000E6, L"Aptor Produits De Comm Indust", },
  { 0x0000E8, L"Accton Technology Corporation", },
  { 0x0000E9, L"ISICAD, Inc.", },
  { 0x0000ED, L"April", },
  { 0x0000EE, L"Network Designers Limited [also KNX Ltd, a former division]", },
  { 0x0000EF, L"Alantec (now owned by ForeSystems)", },
  { 0x0000F0, L"Samsung", },
  { 0x0000F2, L"Spider Communications (Montreal, not Spider Systems)", },
  { 0x0000F3, L"Gandalf Data Ltd. - Canada", },
  { 0x0000F4, L"Allied Telesis, Inc. (Corega)", },
  { 0x0000F6, L"A.M.C. (Applied Microsystems Corp.)", },
  { 0x0000F8, L"DEC", },
  { 0x0000FB, L"Rechner zur Kommunikation", },
  { 0x0000FD, L"High Level Hardware (Orion, UK)", },
  { 0x0000FF, L"Camtec Electronics (UK) Ltd.", },
  { 0x000102, L"BBN (Bolt Beranek and Newman, Inc.) internal usage (not registered)", },
  { 0x000143, L"IEEE 802", },
  { 0x000150, L"Megahertz (now 3com) modem", },
  { 0x000163, L"NDC (National Datacomm Corporation)", },
  { 0x000168, L"W&G (Wandel & Goltermann) [incorrect according to W&G]", },
  { 0x0001C8, L"Thomas Conrad Corp.", },
  { 0x0001FA, L"Compaq (PageMarq printers)", },
  { 0x000204, L"Novell NE3200", },
  { 0x000205, L"Hamilton (Sparc Clones)", },
  { 0x000216, L"ESI (Extended Systems, Inc) print servers", },
  { 0x000288, L"Global Village (PCcard in Mac portable)", },
  { 0x0003C6, L"Morning Star Technologies Inc", },
  { 0x000400, L"Lexmark (Print Server)", },
  { 0x0004AC, L"IBM PCMCIA Ethernet adapter.", },
  { 0x000502, L"Apple (PCI bus Macs)", },
  { 0x00059A, L"PowerComputing (Mac clone)", },
  { 0x0005A8, L"PowerComputing Mac clones", },
  { 0x00060D, L"Hewlett-Packard JetDirect token-ring interfaces", },
  { 0x000629, L"IBM RISC6000 system", },
  { 0x00067C, L"Cisco", },
  { 0x0006C1, L"Cisco", },
  { 0x000701, L"Racal-Datacom", },
  { 0x00070D, L"Cisco 2511 Token Ring", },
  { 0x000852, L"Technically Elite Concepts", },
  { 0x000855, L"Fermilab", },
  { 0x0008C7, L"Compaq", },
  { 0x001007, L"Cisco Systems Catalyst 1900", },
  { 0x00100B, L"Cisco Systems", },
  { 0x00100D, L"Cisco Systems Catalyst 2924-XL", },
  { 0x001011, L"Cisco Systems Cisco 75xx", },
  { 0x00101F, L"Cisco Systems Catalyst 2901", },
  { 0x001029, L"Cisco Systems Catalyst 5000", },
  { 0x00102F, L"Cisco Systems Cisco 5000", },
  { 0x00104B, L"3Com 3C905-TX PCI", },
  { 0x00105A, L"3Com Fast Etherlink XL in a Gateway 2000", },
  { 0x001060, L"Billington Novell NE200 Compatible", },
  { 0x001079, L"Cisco 5500 Router", },
  { 0x00107A, L"Ambicom (was Tandy\?)", },
  { 0x00107B, L"Cisco Systems", },
  { 0x001083, L"HP-UX E 9000/889", },
  { 0x0010A4, L"Xircom RealPort 10/100 PC Card", },
  { 0x0010A6, L"Cisco", },
  { 0x0010D7, L"Argosy EN 220 Fast Ethernet PCMCIA", },
  { 0x0010F6, L"Cisco", },
  { 0x001700, L"Kabel", },
  { 0x002000, L"Lexmark (Print Server)", },
  { 0x002005, L"simpletech", },
  { 0x002008, L"Cable & Computer Technology", },
  { 0x00200C, L"Adastra Systems Corp", },
  { 0x002011, L"Canopus Co Ltd", },
  { 0x002017, L"Orbotech", },
  { 0x002018, L"Realtek", },
  { 0x00201A, L"Nbase", },
  { 0x002025, L"Control Technology Inc (Industrial Controls and Network Interfaces)", },
  { 0x002028, L"Bloomberg", },
  { 0x002029, L"TeleProcessing CSU/DSU (now owned by ADC/Kentrox)", },
  { 0x00202B, L"ATML (Advanced Telecommunications Modules, Ltd.)", },
  { 0x002035, L"IBM (International Business Machines) mainframes, Etherjet printers", },
  { 0x002036, L"BMC Software", },
  { 0x002042, L"Datametrics Corp", },
  { 0x002045, L"SolCom Systems Limited", },
  { 0x002048, L"Fore Systems Inc", },
  { 0x00204B, L"Autocomputer Co Ltd", },
  { 0x00204C, L"Mitron Computer Pte Ltd", },
  { 0x002056, L"Neoproducts", },
  { 0x002061, L"Dynatech Communications Inc", },
  { 0x002063, L"Wipro Infotech Ltd", },
  { 0x002066, L"General Magic Inc", },
  { 0x002067, L"Node Runner Inc", },
  { 0x00206B, L"Minolta Co., Ltd Network printers", },
  { 0x002078, L"Runtop Inc", },
  { 0x002085, L"3COM SuperStack II UPS management module", },
  { 0x00208A, L"Sonix Communications Ltd", },
  { 0x00208B, L"Focus Enhancements", },
  { 0x00208C, L"Galaxy Networks Inc", },
  { 0x002094, L"Cubix Corporation", },
  { 0x0020A5, L"Newer Technology", },
  { 0x0020A6, L"Proxim Inc", },
  { 0x0020A7, L"Pairgain Technologies, Inc.", },
  { 0x0020AF, L"3COM Corporation", },
  { 0x0020B2, L"CSP (Printline Multiconnectivity converter)", },
  { 0x0020B6, L"Agile Networks Inc", },
  { 0x0020B9, L"Metricom, Inc.", },
  { 0x0020C5, L"Eagle NE2000", },
  { 0x0020C6, L"NECTEC", },
  { 0x0020D0, L"Versalynx Corp. \"The One Port\" terminal server", },
  { 0x0020D2, L"RAD Data Communications Ltd", },
  { 0x0020D3, L"OST (Ouet Standard Telematique)", },
  { 0x0020D8, L"NetWave", },
  { 0x0020DA, L"Xylan", },
  { 0x0020DC, L"Densitron Taiwan Ltd", },
  { 0x0020E0, L"PreMax PE-200 (PCMCIA NE2000-clone card, sold by InfoExpress)", },
  { 0x0020E5, L"Apex Data", },
  { 0x0020EE, L"Gtech Corporation", },
  { 0x0020F6, L"Net Tek & Karlnet Inc", },
  { 0x0020F8, L"Carrera Computers Inc", },
  { 0x0020FC, L"Matrox", },
  { 0x004001, L"Zero One Technology Co Ltd (ZyXEL\?)", },
  { 0x004005, L"TRENDware International Inc.; Linksys; Simple Net; all three reported", },
  { 0x004009, L"Tachibana Tectron Co Ltd", },
  { 0x00400B, L"Crescendo (now owned by Cisco)", },
  { 0x00400C, L"General Micro Systems, Inc.", },
  { 0x00400D, L"LANNET Data Communications", },
  { 0x004010, L"Sonic Mac Ethernet interfaces", },
  { 0x004011, L"Facilities Andover Environmental Controllers", },
  { 0x004013, L"NTT Data Communication Systems Corp", },
  { 0x004014, L"Comsoft Gmbh", },
  { 0x004015, L"Ascom", },
  { 0x004017, L"XCd XJet - HP printer server card", },
  { 0x00401C, L"AST Pentium/90 PC (emulating AMD EISA card)", },
  { 0x00401F, L"Colorgraph Ltd", },
  { 0x004020, L"Pilkington Communication", },
  { 0x004023, L"Logic Corporation", },
  { 0x004025, L"Molecular Dynamics", },
  { 0x004026, L"Melco Inc", },
  { 0x004027, L"SMC Massachusetts [Had:Sigma (\?), maybe the \"S\"\?]", },
  { 0x004028, L"Netcomm", },
  { 0x00402A, L"Canoga-Perkins", },
  { 0x00402B, L"TriGem", },
  { 0x00402F, L"Xlnt Designs Inc (XDI)", },
  { 0x004030, L"GK Computer", },
  { 0x004032, L"Digital Communications", },
  { 0x004033, L"Addtron Technology Co., Ltd.", },
  { 0x004036, L"TribeStar", },
  { 0x004039, L"Optec Daiichi Denko Co Ltd", },
  { 0x00403C, L"Forks, Inc.", },
  { 0x004041, L"Fujikura Ltd.", },
  { 0x004043, L"Nokia Data Communications", },
  { 0x004048, L"SMD Informatica S.A.", },
  { 0x00404C, L"Hypertec Pty Ltd.", },
  { 0x00404D, L"Telecomm Techniques", },
  { 0x00404F, L"Space & Naval Warfare Systems", },
  { 0x004050, L"Ironics, Incorporated", },
  { 0x004052, L"Star Technologies Inc", },
  { 0x004053, L"Datum [Bancomm Division] TymServe 2000", },
  { 0x004054, L"Thinking Machines Corporation", },
  { 0x004057, L"Lockheed-Sanders", },
  { 0x004059, L"Yoshida Kogyo K.K.", },
  { 0x00405B, L"Funasset Limited", },
  { 0x00405D, L"Star-Tek Inc", },
  { 0x004066, L"Hitachi Cable, Ltd.", },
  { 0x004067, L"Omnibyte Corporation", },
  { 0x004068, L"Extended Systems", },
  { 0x004069, L"Lemcom Systems Inc", },
  { 0x00406A, L"Kentek Information Systems Inc", },
  { 0x00406E, L"Corollary, Inc.", },
  { 0x00406F, L"Sync Research Inc", },
  { 0x004072, L"Applied Innovation", },
  { 0x004074, L"Cable and Wireless", },
  { 0x004076, L"AMP Incorporated", },
  { 0x004078, L"Wearnes Automation Pte Ltd", },
  { 0x00407F, L"Agema Infrared Systems AB", },
  { 0x004082, L"Laboratory Equipment Corp", },
  { 0x004085, L"SAAB Instruments AB", },
  { 0x004086, L"Michels & Kleberhoff Computer", },
  { 0x004087, L"Ubitrex Corporation", },
  { 0x004088, L"Mobuis NuBus (Mac) combination video/EtherTalk", },
  { 0x00408A, L"TPS Teleprocessing Sys. Gmbh", },
  { 0x00408C, L"Axis Communications AB", },
  { 0x00408E, L"CXR/Digilog", },
  { 0x00408F, L"WM-Data Minfo AB", },
  { 0x004090, L"Ansel Communications PC NE2000 compatible twisted-pair ethernet cards", },
  { 0x004091, L"Procomp Industria Eletronica", },
  { 0x004092, L"ASP Computer Products, Inc.", },
  { 0x004094, L"Shographics Inc", },
  { 0x004095, L"Eagle Technologies [UMC also reported]", },
  { 0x004096, L"Telesystems SLW Inc", },
  { 0x00409A, L"Network Express Inc", },
  { 0x00409C, L"Transware", },
  { 0x00409D, L"DigiBoard Ethernet-ISDN bridges", },
  { 0x00409E, L"Concurrent Technologies Ltd.", },
  { 0x00409F, L"Lancast/Casat Technology Inc", },
  { 0x0040A4, L"Rose Electronics", },
  { 0x0040A6, L"Cray Research Inc.", },
  { 0x0040AA, L"Valmet Automation Inc", },
  { 0x0040AD, L"SMA Regelsysteme Gmbh", },
  { 0x0040AE, L"Delta Controls, Inc.", },
  { 0x0040AF, L"Digital Products, Inc. (DPI).", },
  { 0x0040B4, L"3COM K.K.", },
  { 0x0040B5, L"Video Technology Computers Ltd", },
  { 0x0040B6, L"Computerm Corporation", },
  { 0x0040B9, L"MACQ Electronique SA", },
  { 0x0040BD, L"Starlight Networks Inc", },
  { 0x0040C1, L"Bizerba-Werke Wilheim Kraut", },
  { 0x0040C2, L"Applied Computing Devices", },
  { 0x0040C3, L"Fischer and Porter Co.", },
  { 0x0040C5, L"Micom Communications Corp.", },
  { 0x0040C6, L"Fibernet Research, Inc.", },
  { 0x0040C7, L"Danpex Corporation", },
  { 0x0040C8, L"Milan Technology Corp.", },
  { 0x0040CC, L"Silcom Manufacturing Technology Inc", },
  { 0x0040CF, L"Strawberry Tree Inc", },
  { 0x0040D0, L"DEC/Compaq", },
  { 0x0040D2, L"Pagine Corporation", },
  { 0x0040D4, L"Gage Talker Corp.", },
  { 0x0040D7, L"Studio Gen Inc", },
  { 0x0040D8, L"Ocean Office Automation Ltd", },
  { 0x0040DC, L"Tritec Electronic Gmbh", },
  { 0x0040DF, L"Digalog Systems, Inc.", },
  { 0x0040E1, L"Marner International Inc", },
  { 0x0040E2, L"Mesa Ridge Technologies Inc", },
  { 0x0040E3, L"Quin Systems Ltd", },
  { 0x0040E5, L"Sybus Corporation", },
  { 0x0040E7, L"Arnos Instruments & Computer", },
  { 0x0040E9, L"Accord Systems, Inc.", },
  { 0x0040EA, L"PlainTree Systems Inc", },
  { 0x0040ED, L"Network Controls International Inc", },
  { 0x0040F0, L"Micro Systems Inc", },
  { 0x0040F1, L"Chuo Electronics Co., Ltd.", },
  { 0x0040F4, L"Cameo Communications, Inc.", },
  { 0x0040F5, L"OEM Engines", },
  { 0x0040F6, L"Katron Computers Inc", },
  { 0x0040F9, L"Combinet", },
  { 0x0040FA, L"Microboards Inc", },
  { 0x0040FB, L"Cascade Communications Corp.", },
  { 0x0040FD, L"LXE", },
  { 0x0040FF, L"Telebit Corporation Personal NetBlazer", },
  { 0x004854, L"Digital SemiConductor 21143/2 based 10/100", },
  { 0x004F49, L"Realtek", },
  { 0x004F4B, L"Pine Technology Ltd.", },
  { 0x005004, L"3com 3C90X", },
  { 0x00500F, L"Cisco", },
  { 0x00504D, L"Repotec Group", },
  { 0x00504E, L"UMC UM9008 NE2000-compatible ISA Card for PC", },
  { 0x005050, L"Cisco", },
  { 0x005069, L"PixStream Incorporated", },
  { 0x0050BD, L"Cisco", },
  { 0x0050E2, L"Cisco", },
  { 0x005500, L"Xerox", },
  { 0x006008, L"3Com 3Com PCI form factor 3C905 TX board", },
  { 0x006009, L"Cisco Catalyst 5000 Ethernet switch", },
  { 0x006025, L"Active Imaging Inc.", },
  { 0x00602F, L"Cisco", },
  { 0x006030, L"VillageTronic used on Amiga", },
  { 0x00603E, L"Cisco 100Mbps interface", },
  { 0x006047, L"Cisco", },
  { 0x00604E, L"Cycle Computer (Sun MotherBoard Replacements)", },
  { 0x006052, L"Realtek (RTL 8029 == PCI NE2000)", },
  { 0x00605C, L"Cisco", },
  { 0x006067, L"Acer Lan", },
  { 0x006070, L"Cisco routers (2524 and 4500)", },
  { 0x006083, L"Cisco Systems, Inc. 3620/3640 routers", },
  { 0x00608C, L"3Com (1990 onwards)", },
  { 0x006094, L"AMD PCNET PCI", },
  { 0x006097, L"3Com", },
  { 0x0060B0, L"Hewlett-Packard", },
  { 0x0060F5, L"Phobos FastEthernet for Unix WS", },
  { 0x008000, L"Multitech Systems Inc", },
  { 0x008001, L"Periphonics Corporation", },
  { 0x008004, L"Antlow Computers, Ltd.", },
  { 0x008005, L"Cactus Computer Inc.", },
  { 0x008006, L"Compuadd Corporation", },
  { 0x008007, L"Dlog NC-Systeme", },
  { 0x008009, L"Jupiter Systems (older MX-600 series machines)", },
  { 0x00800D, L"Vosswinkel FU", },
  { 0x00800F, L"SMC (Standard Microsystem Corp.)", },
  { 0x008010, L"Commodore", },
  { 0x008012, L"IMS Corp. IMS failure analysis tester", },
  { 0x008013, L"Thomas Conrad Corp.", },
  { 0x008015, L"Seiko Systems Inc", },
  { 0x008016, L"Wandel & Goltermann", },
  { 0x008017, L"PFU", },
  { 0x008019, L"Dayna Communications \"Etherprint\" product", },
  { 0x00801A, L"Bell Atlantic", },
  { 0x00801B, L"Kodiak Technology", },
  { 0x00801C, L"Cisco", },
  { 0x008021, L"Newbridge Networks Corporation", },
  { 0x008023, L"Integrated Business Networks", },
  { 0x008024, L"Kalpana", },
  { 0x008026, L"Network Products Corporation", },
  { 0x008029, L"Microdyne Corporation", },
  { 0x00802A, L"Test Systems & Simulations Inc", },
  { 0x00802C, L"The Sage Group PLC", },
  { 0x00802D, L"Xylogics, Inc. Annex terminal servers", },
  { 0x00802E, L"Plexcom, Inc.", },
  { 0x008033, L"Formation (\?)", },
  { 0x008034, L"SMT-Goupil", },
  { 0x008035, L"Technology Works", },
  { 0x008037, L"Ericsson Business Comm.", },
  { 0x008038, L"Data Research & Applications", },
  { 0x00803B, L"APT Communications, Inc.", },
  { 0x00803D, L"Surigiken Co Ltd", },
  { 0x00803E, L"Synernetics", },
  { 0x00803F, L"Hyundai Electronics", },
  { 0x008042, L"Force Computers", },
  { 0x008043, L"Networld Inc", },
  { 0x008045, L"Matsushita Electric Ind Co", },
  { 0x008046, L"University of Toronto", },
  { 0x008048, L"Compex, used by Commodore and DEC at least", },
  { 0x008049, L"Nissin Electric Co Ltd", },
  { 0x00804C, L"Contec Co., Ltd.", },
  { 0x00804D, L"Cyclone Microsystems, Inc.", },
  { 0x008051, L"ADC Fibermux", },
  { 0x008052, L"Network Professor", },
  { 0x008057, L"Adsoft Ltd", },
  { 0x00805A, L"Tulip Computers International BV", },
  { 0x00805B, L"Condor Systems, Inc.", },
  { 0x00805C, L"Agilis(\?)", },
  { 0x00805F, L"Compaq Computer Corporation", },
  { 0x008060, L"Network Interface Corporation", },
  { 0x008062, L"Interface Co.", },
  { 0x008063, L"Richard Hirschmann Gmbh & Co", },
  { 0x008064, L"Wyse", },
  { 0x008067, L"Square D Company", },
  { 0x008069, L"Computone Systems", },
  { 0x00806A, L"ERI (Empac Research Inc.)", },
  { 0x00806B, L"Schmid Telecommunication", },
  { 0x00806C, L"Cegelec Projects Ltd", },
  { 0x00806D, L"Century Systems Corp.", },
  { 0x00806E, L"Nippon Steel Corporation", },
  { 0x00806F, L"Onelan Ltd", },
  { 0x008071, L"SAI Technology", },
  { 0x008072, L"Microplex Systems Ltd", },
  { 0x008074, L"Fisher Controls", },
  { 0x008079, L"Microbus Designs Ltd", },
  { 0x00807B, L"Artel Communications Corp.", },
  { 0x00807C, L"FiberCom", },
  { 0x00807D, L"Equinox Systems Inc", },
  { 0x008082, L"PEP Modular Computers Gmbh", },
  { 0x008086, L"Computer Generation Inc.", },
  { 0x008087, L"Okidata", },
  { 0x00808A, L"Summit (\?)", },
  { 0x00808B, L"Dacoll Limited", },
  { 0x00808C, L"Netscout Systems (formerly Frontier Software Development)", },
  { 0x00808D, L"Westcove Technology BV", },
  { 0x00808E, L"Radstone Technology", },
  { 0x008090, L"Microtek International Inc", },
  { 0x008092, L"Japan Computer Industry, Inc.", },
  { 0x008093, L"Xyron Corporation", },
  { 0x008094, L"Sattcontrol AB", },
  { 0x008096, L"HDS (Human Designed Systems) X terminals", },
  { 0x008098, L"TDK Corporation", },
  { 0x00809A, L"Novus Networks Ltd", },
  { 0x00809B, L"Justsystem Corporation", },
  { 0x00809D, L"Datacraft Manufactur\'g Pty Ltd", },
  { 0x00809F, L"Alcatel Business Systems", },
  { 0x0080A1, L"Microtest", },
  { 0x0080A3, L"Lantronix (see also 0800A3)", },
  { 0x0080A6, L"Republic Technology Inc", },
  { 0x0080A7, L"Measurex Corp", },
  { 0x0080AD, L"CNet Technology Used by Telebit (among others)", },
  { 0x0080AE, L"Hughes Network Systems", },
  { 0x0080AF, L"Allumer Co., Ltd.", },
  { 0x0080B1, L"Softcom A/S", },
  { 0x0080B2, L"NET (Network Equipment Technologies)", },
  { 0x0080B6, L"Themis corporation", },
  { 0x0080BA, L"Specialix (Asia) Pte Ltd", },
  { 0x0080C0, L"Penril Datability Networks", },
  { 0x0080C2, L"IEEE 802.1 Committee", },
  { 0x0080C6, L"Soho", },
  { 0x0080C7, L"Xircom, Inc.", },
  { 0x0080C8, L"D-Link (also Solectek Pocket Adapters, and LinkSys PCMCIA)", },
  { 0x0080C9, L"Alberta Microelectronic Centre", },
  { 0x0080CE, L"Broadcast Television Systems", },
  { 0x0080D0, L"Computer Products International", },
  { 0x0080D3, L"Shiva Appletalk-Ethernet interface", },
  { 0x0080D4, L"Chase Limited", },
  { 0x0080D6, L"Apple Mac Portable(\?)", },
  { 0x0080D7, L"Fantum Electronics", },
  { 0x0080D8, L"Network Peripherals", },
  { 0x0080DA, L"Bruel & Kjaer", },
  { 0x0080E0, L"XTP Systems Inc", },
  { 0x0080E3, L"Coral (\?)", },
  { 0x0080E7, L"Lynwood Scientific Dev Ltd", },
  { 0x0080EA, L"The Fiber Company", },
  { 0x0080F0, L"Kyushu Matsushita Electric Co", },
  { 0x0080F1, L"Opus", },
  { 0x0080F3, L"Sun Electronics Corp", },
  { 0x0080F4, L"Telemechanique Electrique", },
  { 0x0080F5, L"Quantel Ltd", },
  { 0x0080F7, L"Zenith Communications Products", },
  { 0x0080FB, L"BVM Limited", },
  { 0x0080FE, L"Azure Technologies Inc", },
  { 0x009004, L"3Com", },
  { 0x009027, L"Intel", },
  { 0x0090B1, L"Cisco", },
  { 0x00902B, L"Cisco Ethernet Switches and Light Streams", },
  { 0x009086, L"Cisco", },
  { 0x009092, L"Cisco", },
  { 0x0090AB, L"Cisco", },
  { 0x0090B1, L"Cisco", },
  { 0x0090F2, L"Cisco Ethernet Switches and Light Streams", },
  { 0x00A000, L"Bay Networks Ethernet switch", },
  { 0x00A00C, L"Kingmax Technology Inc. PCMCIA card", },
  { 0x00A024, L"3com", },
  { 0x00A040, L"Apple (PCI Mac)", },
  { 0x00A04B, L"Sonic Systems Inc. EtherFE 10/100 PCI for Mac or PC", },
  { 0x00A073, L"Com21", },
  { 0x00A083, L"Intel", },
  { 0x00A092, L"Intermate International [LAN printer interfaces]", },
  { 0x00A0AE, L"Network Peripherals, Inc.", },
  { 0x00A0C8, L"Adtran, Inc.", },
  { 0x00A0C9, L"Intel (PRO100B and PRO100+) [used on Cisco PIX firewall among others]", },
  { 0x00A0CC, L"Lite-On (used by MacSense in Adapter for Mac, also seen in PCs)", },
  { 0x00A0D1, L"National Semiconductor [COMPAQ Docking Station]", },
  { 0x00A0D2, L"Allied Telesyn", },
  { 0x00AA00, L"Intel", },
  { 0x00B0D0, L"Computer Products International", },
  { 0x00C000, L"Lanoptics Ltd", },
  { 0x00C001, L"Diatek Patient Managment", },
  { 0x00C002, L"Sercomm Corporation", },
  { 0x00C003, L"Globalnet Communications", },
  { 0x00C004, L"Japan Business Computer Co.Ltd", },
  { 0x00C005, L"Livingston Enterprises Inc Portmaster (OEMed by Cayman)", },
  { 0x00C006, L"Nippon Avionics Co Ltd", },
  { 0x00C007, L"Pinnacle Data Systems Inc", },
  { 0x00C008, L"Seco SRL", },
  { 0x00C009, L"KT Technology (s) Pte Inc", },
  { 0x00C00A, L"Micro Craft", },
  { 0x00C00B, L"Norcontrol A.S.", },
  { 0x00C00C, L"ARK PC Technology, Inc.", },
  { 0x00C00D, L"Advanced Logic Research Inc", },
  { 0x00C00E, L"Psitech Inc", },
  { 0x00C00F, L"QNX Software Systems Ltd. [also Quantum Software Systems Ltd]", },
  { 0x00C011, L"Interactive Computing Devices", },
  { 0x00C012, L"Netspan Corp", },
  { 0x00C013, L"Netrix", },
  { 0x00C014, L"Telematics Calabasas", },
  { 0x00C015, L"New Media Corp", },
  { 0x00C016, L"Electronic Theatre Controls", },
  { 0x00C017, L"Fluke", },
  { 0x00C018, L"Lanart Corp", },
  { 0x00C01A, L"Corometrics Medical Systems", },
  { 0x00C01B, L"Socket Communications", },
  { 0x00C01C, L"Interlink Communications Ltd.", },
  { 0x00C01D, L"Grand Junction Networks, Inc. (Cisco Catalyst also reported)", },
  { 0x00C01F, L"S.E.R.C.E.L.", },
  { 0x00C020, L"Arco Electronic, Control Ltd.", },
  { 0x00C021, L"Netexpress", },
  { 0x00C023, L"Tutankhamon Electronics", },
  { 0x00C024, L"Eden Sistemas De Computacao SA", },
  { 0x00C025, L"Dataproducts Corporation", },
  { 0x00C027, L"Cipher Systems, Inc.", },
  { 0x00C028, L"Jasco Corporation", },
  { 0x00C029, L"Kabel Rheydt AG", },
  { 0x00C02A, L"Ohkura Electric Co", },
  { 0x00C02B, L"Gerloff Gesellschaft Fur", },
  { 0x00C02C, L"Centrum Communications, Inc.", },
  { 0x00C02D, L"Fuji Photo Film Co., Ltd.", },
  { 0x00C02E, L"Netwiz", },
  { 0x00C02F, L"Okuma Corp", },
  { 0x00C030, L"Integrated Engineering B. V.", },
  { 0x00C031, L"Design Research Systems, Inc.", },
  { 0x00C032, L"I-Cubed Limited", },
  { 0x00C033, L"Telebit Corporation", },
  { 0x00C034, L"Dale Computer Corporation", },
  { 0x00C035, L"Quintar Company", },
  { 0x00C036, L"Raytech Electronic Corp", },
  { 0x00C039, L"Silicon Systems", },
  { 0x00C03B, L"Multiaccess Computing Corp", },
  { 0x00C03C, L"Tower Tech S.R.L.", },
  { 0x00C03D, L"Wiesemann & Theis Gmbh", },
  { 0x00C03E, L"Fa. Gebr. Heller Gmbh", },
  { 0x00C03F, L"Stores Automated Systems Inc", },
  { 0x00C040, L"ECCI", },
  { 0x00C041, L"Digital Transmission Systems", },
  { 0x00C042, L"Datalux Corp.", },
  { 0x00C043, L"Stratacom", },
  { 0x00C044, L"Emcom Corporation", },
  { 0x00C045, L"Isolation Systems Inc", },
  { 0x00C046, L"Kemitron Ltd", },
  { 0x00C047, L"Unimicro Systems Inc", },
  { 0x00C048, L"Bay Technical Associates", },
  { 0x00C049, L"US Robotics Total Control (tm) NETServer Card", },
  { 0x00C04D, L"Mitec Ltd", },
  { 0x00C04E, L"Comtrol Corporation", },
  { 0x00C04F, L"Dell", },
  { 0x00C050, L"Toyo Denki Seizo K.K.", },
  { 0x00C051, L"Advanced Integration Research", },
  { 0x00C055, L"Modular Computing Technologies", },
  { 0x00C056, L"Somelec", },
  { 0x00C057, L"Myco Electronics", },
  { 0x00C058, L"Dataexpert Corp", },
  { 0x00C059, L"Nippondenso Corp", },
  { 0x00C05B, L"Networks Northwest Inc", },
  { 0x00C05C, L"Elonex PLC", },
  { 0x00C05D, L"L&N Technologies", },
  { 0x00C05E, L"Vari-Lite Inc", },
  { 0x00C060, L"ID Scandinavia A/S", },
  { 0x00C061, L"Solectek Corporation", },
  { 0x00C063, L"Morning Star Technologies Inc May be miswrite of 0003C6", },
  { 0x00C064, L"General Datacomm Ind Inc", },
  { 0x00C065, L"Scope Communications Inc", },
  { 0x00C066, L"Docupoint, Inc.", },
  { 0x00C067, L"United Barcode Industries", },
  { 0x00C068, L"Philp Drake Electronics Ltd", },
  { 0x00C069, L"California Microwave Inc", },
  { 0x00C06A, L"Zahner-Elektrik Gmbh & Co KG", },
  { 0x00C06B, L"OSI Plus Corporation", },
  { 0x00C06C, L"SVEC Computer Corp", },
  { 0x00C06D, L"Boca Research, Inc.", },
  { 0x00C06F, L"Komatsu Ltd", },
  { 0x00C070, L"Sectra Secure-Transmission AB", },
  { 0x00C071, L"Areanex Communications, Inc.", },
  { 0x00C072, L"KNX Ltd", },
  { 0x00C073, L"Xedia Corporation", },
  { 0x00C074, L"Toyoda Automatic Loom Works Ltd", },
  { 0x00C075, L"Xante Corporation ", },
  { 0x00C076, L"I-Data International A-S", },
  { 0x00C077, L"Daewoo Telecom Ltd", },
  { 0x00C078, L"Computer Systems Engineering", },
  { 0x00C079, L"Fonsys Co Ltd", },
  { 0x00C07A, L"Priva BV", },
  { 0x00C07B, L"Ascend Communications ISDN bridges/routers", },
  { 0x00C07D, L"RISC Developments Ltd", },
  { 0x00C07F, L"Nupon Computing Corp", },
  { 0x00C080, L"Netstar Inc", },
  { 0x00C081, L"Metrodata Ltd", },
  { 0x00C082, L"Moore Products Co", },
  { 0x00C084, L"Data Link Corp Ltd", },
  { 0x00C085, L"Canon", },
  { 0x00C086, L"The Lynk Corporation", },
  { 0x00C087, L"UUNET Technologies Inc", },
  { 0x00C089, L"Telindus Distribution", },
  { 0x00C08A, L"Lauterbach Datentechnik Gmbh", },
  { 0x00C08B, L"RISQ Modular Systems Inc", },
  { 0x00C08C, L"Performance Technologies Inc", },
  { 0x00C08D, L"Tronix Product Development", },
  { 0x00C08E, L"Network Information Technology", },
  { 0x00C08F, L"Matsushita Electric Works, Ltd.", },
  { 0x00C090, L"Praim S.R.L.", },
  { 0x00C091, L"Jabil Circuit, Inc.", },
  { 0x00C092, L"Mennen Medical Inc", },
  { 0x00C093, L"Alta Research Corp.", },
  { 0x00C095, L"Znyx (Network Appliance); Jupiter Systems (MX-700); Apple (G3) all seen", },
  { 0x00C096, L"Tamura Corporation", },
  { 0x00C097, L"Archipel SA", },
  { 0x00C098, L"Chuntex Electronic Co., Ltd.", },
  { 0x00C09B, L"Reliance Comm/Tec, R-Tec Systems Inc", },
  { 0x00C09C, L"TOA Electronic Ltd", },
  { 0x00C09D, L"Distributed Systems Int\'l, Inc.", },
  { 0x00C09F, L"Quanta Computer Inc", },
  { 0x00C0A0, L"Advance Micro Research, Inc.", },
  { 0x00C0A1, L"Tokyo Denshi Sekei Co", },
  { 0x00C0A2, L"Intermedium A/S", },
  { 0x00C0A3, L"Dual Enterprises Corporation", },
  { 0x00C0A4, L"Unigraf OY", },
  { 0x00C0A7, L"SEEL Ltd", },
  { 0x00C0A8, L"GVC Corporation", },
  { 0x00C0A9, L"Barron McCann Ltd", },
  { 0x00C0AA, L"Silicon Valley Computer", },
  { 0x00C0AB, L"Jupiter Technology Inc", },
  { 0x00C0AC, L"Gambit Computer Communications", },
  { 0x00C0AD, L"Computer Communication Systems", },
  { 0x00C0AE, L"Towercom Co Inc DBA PC House", },
  { 0x00C0B0, L"GCC Technologies,Inc.", },
  { 0x00C0B2, L"Norand Corporation", },
  { 0x00C0B3, L"Comstat Datacomm Corporation", },
  { 0x00C0B4, L"Myson Technology Inc", },
  { 0x00C0B5, L"Corporate Network Systems Inc", },
  { 0x00C0B6, L"Meridian Data Inc", },
  { 0x00C0B7, L"American Power Conversion Corp", },
  { 0x00C0B8, L"Fraser\'s Hill Ltd.", },
  { 0x00C0B9, L"Funk Software Inc", },
  { 0x00C0BA, L"Netvantage", },
  { 0x00C0BB, L"Forval Creative Inc", },
  { 0x00C0BD, L"Inex Technologies, Inc.", },
  { 0x00C0BE, L"Alcatel - Sel", },
  { 0x00C0BF, L"Technology Concepts Ltd", },
  { 0x00C0C0, L"Shore Microsystems Inc", },
  { 0x00C0C1, L"Quad/Graphics Inc", },
  { 0x00C0C2, L"Infinite Networks Ltd.", },
  { 0x00C0C3, L"Acuson Computed Sonography", },
  { 0x00C0C4, L"Computer Operational", },
  { 0x00C0C5, L"SID Informatica", },
  { 0x00C0C6, L"Personal Media Corp", },
  { 0x00C0C8, L"Micro Byte Pty Ltd", },
  { 0x00C0C9, L"Bailey Controls Co", },
  { 0x00C0CA, L"Alfa, Inc.", },
  { 0x00C0CB, L"Control Technology Corporation", },
  { 0x00C0CD, L"Comelta S.A.", },
  { 0x00C0D0, L"Ratoc System Inc", },
  { 0x00C0D1, L"Comtree Technology Corporation (EFA also reported)", },
  { 0x00C0D2, L"Syntellect Inc", },
  { 0x00C0D4, L"Axon Networks Inc", },
  { 0x00C0D5, L"Quancom Electronic Gmbh", },
  { 0x00C0D6, L"J1 Systems, Inc.", },
  { 0x00C0D9, L"Quinte Network Confidentiality Equipment Inc", },
  { 0x00C0DB, L"IPC Corporation (Pte) Ltd", },
  { 0x00C0DC, L"EOS Technologies, Inc.", },
  { 0x00C0DE, L"ZComm Inc", },
  { 0x00C0DF, L"Kye Systems Corp", },
  { 0x00C0E1, L"Sonic Solutions", },
  { 0x00C0E2, L"Calcomp, Inc.", },
  { 0x00C0E3, L"Ositech Communications Inc", },
  { 0x00C0E4, L"Landis & Gyr Powers Inc", },
  { 0x00C0E5, L"GESPAC S.A.", },
  { 0x00C0E6, L"TXPORT", },
  { 0x00C0E7, L"Fiberdata AB", },
  { 0x00C0E8, L"Plexcom Inc", },
  { 0x00C0E9, L"Oak Solutions Ltd", },
  { 0x00C0EA, L"Array Technology Ltd.", },
  { 0x00C0EC, L"Dauphin Technology", },
  { 0x00C0ED, L"US Army Electronic Proving Ground", },
  { 0x00C0EE, L"Kyocera Corporation", },
  { 0x00C0EF, L"Abit Corporation", },
  { 0x00C0F0, L"Kingston Technology Corporation", },
  { 0x00C0F1, L"Shinko Electric Co Ltd", },
  { 0x00C0F2, L"Transition Engineering Inc", },
  { 0x00C0F3, L"Network Communications Corp", },
  { 0x00C0F4, L"Interlink System Co., Ltd.", },
  { 0x00C0F5, L"Metacomp Inc", },
  { 0x00C0F6, L"Celan Technology Inc.", },
  { 0x00C0F7, L"Engage Communication, Inc.", },
  { 0x00C0F8, L"About Computing Inc.", },
  { 0x00C0FA, L"Canary Communications Inc", },
  { 0x00C0FB, L"Advanced Technology Labs", },
  { 0x00C0FC, L"ASDG Incorporated", },
  { 0x00C0FD, L"Prosum", },
  { 0x00C0FF, L"Box Hill Systems Corporation", },
  { 0x00DD00, L"Ungermann-Bass IBM RT", },
  { 0x00DD01, L"Ungermann-Bass", },
  { 0x00DD08, L"Ungermann-Bass", },
  { 0x00E011, L"Uniden Corporation", },
  { 0x00E014, L"Cisco", },
  { 0x00E016, L"rapid-city (now a part of bay networks)", },
  { 0x00E018, L"Asustek Intel 82558-based Integrated Fast Ethernet for WIM", },
  { 0x00E01E, L"Cisco", },
  { 0x00E029, L"SMC EtherPower II 10/100", },
  { 0x00E02C, L"AST - built into 5166M PC motherboard (win95 id\'s as Intel)", },
  { 0x00E034, L"Cisco", },
  { 0x00E039, L"Paradyne 7112 T1 DSU/CSU", },
  { 0x00E04F, L"Cisco", },
  { 0x00E07D, L"Encore (Netronix\?) 10/100 PCI Fast ethernet card", },
  { 0x00E081, L"Tyan Computer Corp. Onboard Intel 82558 10/100", },
  { 0x00E083, L"Jato Technologies, Inc.", },
  { 0x00E08F, L"Cisco Systems Catalyst 2900 series", },
  { 0x00E098, L"Linksys PCMCIA card", },
  { 0x00E0A3, L"Cisco Systems Catalyst 1924", },
  { 0x00E0B0, L"Cisco Systems Various systems reported", },
  { 0x00E0B8, L"AMD PCNet in a Gateway 2000", },
  { 0x00E0C5, L"BCOM Electronics Inc.", },
  { 0x00E0ED, L"New Link", },
  { 0x00E0F7, L"Cisco", },
  { 0x00E0F9, L"Cisco", },
  { 0x00E0FE, L"Cisco", },
  { 0x020406, L"BBN internal usage (not registered)", },
  { 0x020701, L"Interlan [now Racal-InterLAN] DEC (UNIBUS or QBUS), Apollo, Cisco", },
  { 0x020701, L"Racal-Datacom", },
  { 0x026060, L"3Com", },
  { 0x026086, L"Satelcom MegaPac (UK)", },
  { 0x02608C, L"3Com IBM PC; Imagen; Valid; Cisco; Macintosh", },
  { 0x02A0C9, L"Intel", },
  { 0x02AA3C, L"Olivetti", },
  { 0x02CF1F, L"CMC Masscomp; Silicon Graphics; Prime EXL", },
  { 0x02E03B, L"Prominet Corporation Gigabit Ethernet Switch", },
  { 0x02E6D3, L"BTI (Bus-Tech, Inc.) IBM Mainframes", },
  { 0x048845, L"Bay Networks token ring line card", },
  { 0x080001, L"Computer Vision", },
  { 0x080002, L"3Com (formerly Bridge)", },
  { 0x080003, L"ACC (Advanced Computer Communications)", },
  { 0x080005, L"Symbolics Symbolics LISP machines", },
  { 0x080006, L"Siemens Nixdorf PC clone", },
  { 0x080007, L"Apple", },
  { 0x080008, L"BBN (Bolt Beranek and Newman, Inc.)", },
  { 0x080009, L"Hewlett-Packard", },
  { 0x08000A, L"Nestar Systems", },
  { 0x08000B, L"Unisys also Ascom-Timeplex (former Unisys subsidiary)", },
  { 0x08000D, L"ICL (International Computers, Ltd.)", },
  { 0x08000E, L"NCR/AT&T", },
  { 0x08000F, L"SMC (Standard Microsystems Corp.)", },
  { 0x080010, L"AT&T [misrepresentation of 800010\?]", },
  { 0x080011, L"Tektronix, Inc.", },
  { 0x080014, L"Excelan BBN Butterfly, Masscomp, Silicon Graphics", },
  { 0x080017, L"National Semiconductor Corp. (used to have Network System Corp., wrong NSC)", },
  { 0x08001A, L"Tiara\? (used to have Data General)", },
  { 0x08001B, L"Data General", },
  { 0x08001E, L"Apollo", },
  { 0x08001F, L"Sharp", },
  { 0x080020, L"Sun", },
  { 0x080022, L"NBI (Nothing But Initials)", },
  { 0x080023, L"Matsushita Denso", },
  { 0x080025, L"CDC", },
  { 0x080026, L"Norsk Data (Nord)", },
  { 0x080027, L"PCS Computer Systems GmbH", },
  { 0x080028, L"TI Explorer", },
  { 0x08002B, L"DEC", },
  { 0x08002E, L"Metaphor", },
  { 0x08002F, L"Prime Computer Prime 50-Series LHC300", },
  { 0x080030, L"CERN", },
  { 0x080032, L"Tigan", },
  { 0x080036, L"Intergraph CAE stations", },
  { 0x080037, L"Fuji Xerox", },
  { 0x080038, L"Bull", },
  { 0x080039, L"Spider Systems", },
  { 0x08003B, L"Torus Systems", },
  { 0x08003D, L"cadnetix", },
  { 0x08003E, L"Motorola VME bus processor modules", },
  { 0x080041, L"DCA (Digital Comm. Assoc.)", },
  { 0x080044, L"DSI (DAVID Systems, Inc.)", },
  { 0x080045, L"\?\?\?\? (maybe Xylogics, but they claim not to know this number)", },
  { 0x080046, L"Sony", },
  { 0x080047, L"Sequent", },
  { 0x080048, L"Eurotherm Gauging Systems", },
  { 0x080049, L"Univation", },
  { 0x08004C, L"Encore", },
  { 0x08004E, L"BICC [3com bought BICC, so may appear on 3com equipment as well]", },
  { 0x080051, L"Experdata", },
  { 0x080056, L"Stanford University", },
  { 0x080057, L"Evans & Sutherland (\?)", },
  { 0x080058, L"\?\?\? DECsystem-20", },
  { 0x08005A, L"IBM", },
  { 0x080066, L"AGFA printers, phototypesetters etc.", },
  { 0x080067, L"Comdesign", },
  { 0x080068, L"Ridge", },
  { 0x080069, L"Silicon Graphics", },
  { 0x08006A, L"ATTst (\?)", },
  { 0x08006E, L"Excelan", },
  { 0x080070, L"Mitsubishi", },
  { 0x080074, L"Casio", },
  { 0x080075, L"DDE (Danish Data Elektronik A/S)", },
  { 0x080077, L"TSL (now Retix)", },
  { 0x080079, L"Silicon Graphics", },
  { 0x08007C, L"Vitalink TransLAN III", },
  { 0x080080, L"XIOS", },
  { 0x080081, L"Crosfield Electronics", },
  { 0x080083, L"Seiko Denshi", },
  { 0x080086, L"Imagen/QMS", },
  { 0x080087, L"Xyplex terminal servers", },
  { 0x080088, L"McDATA Corporation", },
  { 0x080089, L"Kinetics AppleTalk-Ethernet interface", },
  { 0x08008B, L"Pyramid", },
  { 0x08008D, L"XyVision XyVision machines", },
  { 0x08008E, L"Tandem / Solbourne Computer \?", },
  { 0x08008F, L"Chipcom Corp.", },
  { 0x080090, L"Retix, Inc. Bridges", },
  { 0x09006A, L"AT&T", },
  { 0x10005A, L"IBM", },
  { 0x100090, L"Hewlett-Packard Advisor products", },
  { 0x1000D4, L"DEC", },
  { 0x1000E0, L"Apple A/UX (modified addresses for licensing)", },
  { 0x2E2E2E, L"LAA (Locally Administered Address) for Meditech Systems", },
  { 0x3C0000, L"3Com dual function (V.34 modem + Ethernet) card", },
  { 0x400003, L"Net Ware (\?)", },
  { 0x444553, L"Microsoft (Windows95 internal \"adapters\")", },
  { 0x444649, L"DFI (Diamond Flower Industries)", },
  { 0x475443, L"GTC (Not registered!) (This number is a multicast!)", },
  { 0x484453, L"HDS \?\?\?", },
  { 0x484C00, L"Network Solutions", },
  { 0x4854E8, L"winbond\?", },
  { 0x4C424C, L"Information Modes software modified addresses (not registered\?)", },
  { 0x525400, L"Realtek (UpTech\? also reported)", },
  { 0x52544C, L"Novell 2000", },
  { 0x5254AB, L"REALTEK (a Realtek 8029 based PCI Card)", },
  { 0x565857, L"Aculab plc audio bridges", },
  { 0x800010, L"AT&T [misrepresented as 080010\? One source claims this is correct]", },
  { 0x80AD00, L"CNET Technology Inc. (Probably an error, see instead 0080AD)", },
  { 0xAA0000, L"DEC obsolete", },
  { 0xAA0001, L"DEC obsolete", },
  { 0xAA0002, L"DEC obsolete", },
  { 0xAA0003, L"DEC Global physical address for some DEC machines", },
  { 0xAA0004, L"DEC Local logical address for DECNET systems", },
  { 0xC00000, L"Western Digital (may be reversed 00 00 C0\?)", },
  { 0xEC1000, L"Enance Source Co., Ltd. PC clones(\?)", },
  { 0xE20C0F, L"Kingston Technologies", },
};

#define VendorTableSize (sizeof(vendors)/sizeof(vendors[0]))
int GetVendorTableSize() { return VendorTableSize; }
const SVendor& SearchVendor(LPBYTE pb)
{
	const static SVendor not_found = { 0xFFFFFF, L"Unknown" };
	DWORD dw(0);
	for (int i =0; i < 3; i++)
	{
		dw <<= 8;
		dw |= *(pb + i);
	}
	int m;
	int r = VendorTableSize - 1;
	int l = 0;
	while (l < r)
    {
		m = (l + r) / 2;
		if (vendors[m].dwCode == dw)
		{
			return vendors[m];
		}
		else if (vendors[m].dwCode < dw)
		{
			l = m + 1;
		}
		else
		{
			r = m;
		}
    }
	if (vendors[l].dwCode == dw)
		return vendors[l];
	return not_found;
}

const SVendor* GetVendor(int i)
{
	return (i >= 0 && i < VendorTableSize) ? &vendors[i] : NULL;
}

LPCOLESTR GetVendorString(LPBYTE pb)
{
	return SearchVendor(pb).pVendor;
}
